class Rect
{
public:
	int x, y, width, height, cx, cy;
	static const int UP = 1;
	static const int RIGHT = 2;
	static const int DOWN = 4;
	static const int LEFT = 8;
	static const int UP_RIGHT = 16;
	static const int DOWN_RIGHT = 32;
	static const int DOWN_LEFT = 64;
	static const int UP_LEFT = 128;
	Rect(int x, int y, int width, int height);
	~Rect(void);
	void updateCenter();
	int contains(int x, int y);
	static bool intersects(Rect& a, Rect& b);
	int sideOf(int x, int y);
	int sideOf4(int x, int y);

};
