#include "Rect.h"

Rect::Rect(int x, int y, int width, int height): x(x), y(y), width(width), height(height){
	updateCenter();
}
Rect::~Rect(void){
}
/*void Rect::draw(){
	ofRect(x, y, width, height);
}*/
void Rect::updateCenter(){
	cx = x+(width>>1);
	cy = y+(height>>1);
}
int Rect::contains(int _x, int _y){
	return _x >= x && _y >= y && _x < x+width && _y < y+height;
}
bool Rect::intersects(Rect& a, Rect& b){
	return !(a.x > b.x+(b.width-1) || a.x+(a.width-1) < b.x || a.y > b.y+(b.height-1) || a.y+(a.height-1) < b.y);
}
int Rect::sideOf(int x, int y){
	updateCenter();
	/*if(x == cx && y == cy) return RIGHT;
	if(x >= this->x+width && y >= y && y < this->y+height) return RIGHT;
	if(x < this->x && y >= y && y < this->y+height) return LEFT;
	if(y >= this->y+height && x >= x && x < this->x+width) return DOWN;
	if(y < this->y && x >= x && x < this->x+width) return UP;
	if(x >= this->x+width && y >= this->y+height) return DOWN_RIGHT;
	if(x < this->x && y >= this->y+height) return DOWN_LEFT;
	if(x < this->x && y < this->y) return UP_LEFT;
	if(x >= this->x+width && y < this->y) return UP_RIGHT;
	int vx = x-cx;
	int vy = y-cy;
	//establish octant
	if(x > cx && y > cy && abs(vy) < abs(vx)) return RIGHT;
	if(x > cx && y > cy && abs(vy) > abs(vx)) return DOWN;
	if(x < cx && y > cy && abs(vy) > abs(vx)) return DOWN;
	if(x < cx && y > cy && abs(vy) < abs(vx)) return LEFT;
	if(x < cx && y < cy && abs(vy) < abs(vx)) return LEFT; // reversal of octant 0
	if(x < cx && y < cy && abs(vy) > abs(vx)) return UP; // reversal of octant 1
	if(x > cx && y < cy && abs(vy) > abs(vx)) return UP; // reversal of octant 2
	if(x > cx && y < cy && abs(vy) < abs(vx)) return RIGHT; // reversal of octant 3
	//line must be on division of octants
	if(y == cy && x > cx) return RIGHT;
	if(x == cx && y > cy) return DOWN;
	if(y == cy && x < cx) return LEFT;
	if(x == cx && y < cy) return UP;
	if(vx == abs(vx) && vy == -abs(vy)) return UP_RIGHT;
	if(vy == abs(vy) && vx == abs(vx)) return DOWN_RIGHT;
	if(vy == abs(vy) && vx == -abs(vx)) return DOWN_LEFT;
	if(vy == -abs(vy) && vx == -abs(vx)) return UP_LEFT;*/
	return 0;
}
int Rect::sideOf4(int x, int y){
	updateCenter();
	/*if(x == cx && y == cy) return RIGHT;
	if(x >= this->x+width && y >= this->y && y < this->y+height) return RIGHT;
	if(x < this->x && y >= this->y && y < this->y+height) return LEFT;
	if(y >= this->y+height && this->x >= this->x && x < this->x+width) return DOWN;
	if(y < this->y && x >= this->x && x < this->x+width) return UP;
	int vx = x-cx;
	int vy = y-cy;
	//establish octant
	if(x > cx && y > cy && abs(vy) < abs(vx)) return RIGHT;
	if(x > cx && y > cy && abs(vy) > abs(vx)) return DOWN;
	if(x < cx && y > cy && abs(vy) > abs(vx)) return DOWN;
	if(x < cx && y > cy && abs(vy) < abs(vx)) return LEFT;
	if(x < cx && y < cy && abs(vy) < abs(vx)) return LEFT; // reversal of octant 0
	if(x < cx && y < cy && abs(vy) > abs(vx)) return UP; // reversal of octant 1
	if(x > cx && y < cy && abs(vy) > abs(vx)) return UP; // reversal of octant 2
	if(x > cx && y < cy && abs(vy) < abs(vx)) return RIGHT; // reversal of octant 3
	//line must be on division of octants
	if(y == cy && x > cx) return RIGHT;
	if(x == cx && y > cy) return DOWN;
	if(y == cy && x < cx) return LEFT;
	if(x == cx && y < cy) return UP;
	if(vx == abs(vx) && vy == -abs(vy)) return RIGHT;
	if(vy == abs(vy) && vx == abs(vx)) return DOWN;
	if(vy == abs(vy) && vx == -abs(vx)) return LEFT;
	if(vy == -abs(vy) && vx == -abs(vx)) return UP;*/
	return 0;
}